/*
 * Archivo para manejo general de funciones en el modulo.
 */
// Inicialización de variables a usar en el archivo
var oMenu, oWin, oWinIns, myVar, minutos, idOption, swfu;

// Inicialización de eventos a ejecutar
$(document).ready(
		function() {
			oMenu = new dhtmlXMenuObject("menu_placeholder", 'dhx_custom');
			oMenu.attachEvent("onClick", menuClick);
			oMenu.setAlign("left");
			oMenu.setOverflowHeight(15);
			oMenu.loadXML($('#menu_placeholder').attr('action'), setTimer);
		}
);

// Función que en base a el tiempo establecido para finalización de sesión, la finaliza
function setTimer()
{
	tourInvoicing();
	var actionTime = oMenu.getUserData('MN_SALIR', 'actionTime');

	$.post(
			actionTime,
			{},
			function(response) {
				minutos = parseInt(response);

				//-- Activa timer solo si estan configurados los minutos
				if (minutos > 0) {
					startTimer();

					$('body').bind(
							'keypress mousemove click change onload',
							{},
							stopTimer
							);
				}
			}
	);
}

// Función que comienza a ejecutar el contador para finalización de sesión.
function startTimer()
{
	myVar = setTimeout(confirmGetOut, minutos * 60 * 1000);

	var timer = $('body div#timer');

	if (timer.length == 0) {
		$('body').append('<div id="timer">&nbsp;</div>');
		timer = $('body div#timer');
	}

	var fecha = moment();
	fecha.add('minutes', minutos);
	timer.html('Fin de sesión: ' + moment(fecha).format('DD/MMM/YYYY HH:mm:ss'));
}

// Función que reinicia el contador para fin de sesión.
function  stopTimer()
{
	clearTimeout(myVar);
	startTimer();
}

// Función que ejecutara las acciones contenidas en la opción del menú elegida.
function menuClick(id_option)
{
	idOption = id_option;
	var script = oMenu.getUserData(idOption, 'script');

	if (script != null && script != '') {
		eval(script);
	} else {
		var action = oMenu.getUserData(idOption, 'action');

		if (action != null && action != '') {
			window.location = action;
		}
	}
}
function tourInvoicing() {
	$.post(
			'./app/tourInvoicing/tourInvoicing.php',
			{
			},
			function(data) {
				if (data == false) {
					loadJSFile('./app/tourInvoicing/tour_usuario_invoicing.js');
				}
			},
			'json'
			);
}
// Ejecuta la acción para cerrar la sesión
function closeApp()
{
	if (confirm('¿Desea finalizar su sesión de trabajo en el sistema?')) {
		var action = oMenu.getUserData(idOption, 'action');
		window.location = action;
	}
}

function confirmGetOut()
{
	alert("A excedido el tiempo de inactividad.");
	window.location = 'index.php';
}

function configuracionSeries()
{
	$.post(
			oMenu.getUserData(idOption, 'action'),
			{
				'id_usuario': $('#id_usuario').val(),
				'nombre_usuario': $('#nombre_usuario').val()
			},
	function(html) {
		oWinUpdSeries = $.newWindow(
				{
					id: 'wUpdSeries',
					title: 'Configuración de Series y Folios',
					width: 550,
					height: 320,
					posx: 200,
					posy: 100,
					content: html,
					modal: true
				}
		);

		$(".window-closeButton").hide();
		baseURL = $("#wSeries").attr('base_url');
		fwURL = $("#wSeries").attr('framework_url');
		loadJSFile(baseURL + 'series.js');
		loadJSFile(fwURL + 'validatorScript.js');
	},
			'html'
			);
}

function configWsdl()
{
	$.post(
			oMenu.getUserData(idOption, 'action'),
			{
				'id_usuario': $('#id_usuario').val(),
				'nombre_usuario': $('#nombre_usuario').val()
			},
	function(html) {
		oWinWsdl = $.newWindow(
				{
					id: 'wUpdSeries',
					title: 'Configuración WSDL',
					width: 450,
					height: 220,
					posx: 200,
					posy: 100,
					content: html,
					modal: true
				}
		);

		baseURL = $("#WsConfigWsdl").attr('base_url');
		fwURL = $("#WsConfigWsdl").attr('framework_url');
		loadJSFile(baseURL + 'wsdl.js');
		loadJSFile(fwURL + 'validatorScript.js');
	},
			'html'
			);
}

function configuracionCuenta()
{
	initCssButtons();
	initInactiveControls();
	$.post(
			oMenu.getUserData(idOption, 'action'),
			{
				'id_usuario': $('#id_usuario').val(),
				'nombre_usuario': $('#nombre_usuario').val()
			},
	function(html) {
		var viewportWidth = parseInt($('body').innerWidth());
		oWinUpdConfCuenta = $.newWindow(
				{
					id: 'wUpdConfiguracionCuenta',
					title: 'Configuración de Informacion',
					height: 575,
					width: 560,
					posx: Math.max((viewportWidth - 700) / 2, 10),
					posy: 20,
					content: html,
					modal: true
				}
		);

		baseURL = $("#wConfiguracionCuenta").attr('base_url');
		fwURL = $("#wConfiguracionCuenta").attr('framework_url');



		loadJSFile(fwURL + 'validatorScript.js');
		loadJSFile(baseURL + 'ventana.js');

	},
			'html'
			);
}

function confPlantillaLogo()
{
	$.post(
			oMenu.getUserData(idOption, 'action'),
			{
				'id_usuario': $('#id_usuario').val(),
				'nombre_usuario': $('#nombre_usuario').val()
			},
	function(html) {
		var viewportWidth = parseInt($('body').innerWidth());
		oWinUpdConfPlantillaLogo = $.newWindow(
				{
					id: 'winPlantillaLogotipo',
					title: 'Configuración de Plantilla html y Logotipo',
					height: 540,
					width: 600,
					posx: Math.max((viewportWidth - 600) / 2, 10),
					posy: 20,
					content: html,
					modal: true
				}
		);

		baseURL = $("#wPlantillaLogotipo").attr('base_url');
		fwURL = $("#wPlantillaLogotipo").attr('framework_url');
		loadJSFile(baseURL + 'ventana.js');
		loadJSFile(fwURL + 'validatorScript.js');
	},
			'html'
			);
}


function confContrasena(id_option) {
	$.post(
			oMenu.getUserData(idOption, 'action'),
			{
				'id_usuario': $('#id_usuario').val(),
				'nombre_usuario': $('#nombre_usuario').val()
			},
	function(html) {
		oWinUpdContrasena = $.newWindow(
				{
					id: 'wUpdContrasena',
					title: 'Configuración de Contraseña',
					width: 550,
					height: 200,
					posx: 200,
					posy: 100,
					content: html,
					modal: true
				}
		);

		$(".window-closeButton").hide();
		baseURL = $("#wContrasena").attr('base_url');
		fwURL = $("#wContrasena").attr('framework_url');
		loadJSFile(baseURL + 'contrasena.js');
		loadJSFile(fwURL + 'validatorScript.js');
	},
			'html'
			);
}