/*
 * Archivo para manejo general de funciones en el modulo.
 */

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
		function() {
			//-- URL base del modulo
			baseURL = $('#dataGrid').attr('base_url');
			myCalendar = new dhtmlXCalendarObject(["calendar_filter"]);
			myCalendar.loadUserLanguage("es");
			regsPage();

			$("#filtroNomina").click(function() {
				var fecha = $("#calendar_filter").val();
				loadGridRows(fecha);
			});
		}
);

// Inicializacion del menu y submenu
function regsPage() {
	//-- Inicialización de Submenu
	oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
	oSubmenu.attachEvent("onClick", submenuClick);
	oSubmenu.loadXML($('#submenu_placeholder').attr('action'));

	//-- Inicialización de Grid
	oGrid = new dhtmlXGridObject('dataGrid');
//	oGrid.attachToolbar();
	oGrid.setHeader("No Empleado,Nombre,Fecha Sello,UUID,Fecha de pago, Dias pagados");
	oGrid.setInitWidths("150,*,150,150,150,150");
	oGrid.setColAlign("left,left,left,left,left,left");
	oGrid.setSkin("dhx_blue");
	oGrid.attachHeader("#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");
	oGrid.setColTypes('ro,ro,ro,ro,ro,ro');
	oGrid.attachEvent('onRowSelect', refreshOptions);
	oGrid.init();
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows(fecha)
{
	$.post(
			$('#dataGrid').attr('url'),
			{fecha_corte: fecha},
	function(response) {
		oGrid.clearAll();
		oGrid.parse(response.data, 'json');
		oGrid.filterByAll();
		refreshOptions();
	},
			'json'
			);
}

function refreshOptions() {
	var nRows = oGrid.getRowsNum();
	var id = oGrid.getSelectedId();
//	var activa = (id !== null && parseInt(oGrid.getUserData(id, 'activa')) == 1);
	var activa = true; // @TODO valida de información del grid
	var timbrado = (id !== null && oGrid.cellById(id, 3).getValue() !== '');

	oSubmenu.enableItem('MNEM_AGREGAR', true);
	oSubmenu.enableItem('MNEM_TIMBRARNOM', nRows > 0);
	oSubmenu.enableItem('MNEM_IMPRIMIRNOM', timbrado);
	oSubmenu.enableItem('MNEM_IMPRIMIRNOMBATCH', nRows > 0);
	oSubmenu.enableItem('MNEM_CORREONOM', timbrado);
	oSubmenu.enableItem('MNEM_CORREOBATCHNOM', nRows > 0);
	oSubmenu.enableItem('MNEM_DESCARGARXML', timbrado);
}


// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');

	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

// Función que ejecuta la acción de agregar un registro.
function addRow(id_option)
{
	$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{},
			function(html) {
				oWinEmp = $.newWindow(
						{
							id: 'wAddRec',
							title: 'Listado de Nomina',
							height: 200,
							width: 540,
							content: html,
							modal: true,
							posx: 240,
							posy: 110
						}
				);
				loadJSFile(baseURL + 'batchNomina/agregar.js');
				$(".window-closeButton").hide();
			}
	)
}

/**
 *Funcion que postea el id del registro a timbrar
 **/
function timbrarNomina(id_option) {
	var fecha_corte = $("#calendar_filter").val();
	if (confirm("\xBFDesea generar el timbrado para este corte?")) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{fecha_corte: fecha_corte},
		function(response) {
			alert(response.message);
//			successfulOperation(response.message);
			loadGridRows();
		},
				'json'
				)
	}

}


function descargarXML(id_option) {
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{'id_factura': id},
		function(response) {
			window.open(response.url, '_blank');
		},
				'json'
				);
	} else {
		alert('Debe seleccionar un registro.');
	}
}

/**
 *Funcion que postea el id del registro a timbrar
 **/
function imprimirNomina(id_option) {
	var id = oGrid.getSelectedId();
	if (id != null) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{nId_nomina: id},
		function(response) {
			if (response.timbrada == '1') {
				var viewportHeight = parseInt($('body').innerHeight());

				oWin = $.newWindow(
						{
							id: 'wInvoiceView',
							title: 'Impresi&oacute;n de Recibo de Nomina',
							height: Math.max(viewportHeight - 74, 500),
							width: 930,
							content: response.html,
							modal: true,
							posx: 15,
							posy: 15
						}
				);
			} else {
				alert('La nomina debe ser timbrada antes de imprimir.');
			}
		},
				'json'
				);
	} else {
		alert('Debe seleccionar un registro a imprimir.');
	}
}

/**
 *Funcion que postea el id del registro a timbrar
 **/
function imprimirNominaBatch(id_option) {
	var fecha_corte = $("#calendar_filter").val();
	
	if (confirm("\xBFDesea imprimir el comprobante para este corte?")) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{fecha_corte: fecha_corte},
		function(response) {
			var viewportHeight = parseInt($('body').innerHeight());
			oWin = $.newWindow(
						{
							id: 'wInvoiceView',
							title: 'Impresi&oacute;n de Recibo de Nomina',
							height: Math.max(viewportHeight - 74, 500),
							width: 930,
							content: response.html,
							modal: true,
							posx: 15,
							posy: 15
						}
				);
		},
				'json'
				)
	}
}



function enviarNomina(id_option) {
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{nId_nomina: id},
				function(html) {
					loadJSFile(baseURL + 'nomina/enviar/enviar.js');
					oWin = $.newWindow({
						id: 'wShowRec',
						title: 'Envio de Comprobante',
						height: 135,
						width: 550,
						content: html,
						modal: true,
						posx: 120,
						posy: 70,
						onWindowClose:
								function() {
								}
					});
				}
		)

	} else {
		alert('Debe seleccionar un registro.');
	}
}


function enviarBatchMail(id_option) {
	var fecha_corte = $("#calendar_filter").val();
	
	if (confirm("\xBFDesea enviar el comprobante para este corte?")) {
		$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{fecha_corte: fecha_corte},
		function(response) {
			alert(response.message);
		},
				'json'
				)
	}
}