/*
* Archivo para manejo general de funciones en el modulo.
*/

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');
		
		regsPage();
		
		$('.custom_date_filter').change(
			function () {
				//-- Obtiene el numero de columna del elemento capturado
				var nCol = $(this).parent().parent().prevAll().length;
				var oInicio = $(this).parent().find('input:eq(0)');
				var oFin = $(this).parent().find('input:eq(1)');

				var inicio = oInicio.val().trim();
				oInicio.val(inicio);
				var fin = oFin.val().trim();
				oFin.val(fin);

				if (inicio.match(/^(\d{2}\/\d{2}\/\d{4})?$/) && inicio.match(/^(\d{2}\/\d{2}\/\d{4})?$/)) {
					if (fin == '') fin = inicio;

					inicio = (inicio == '' ? 0 : parseInt(inicio.replace(/(\d{2}).(\d{2}).(\d{4})/, '$3$2$1')));
					fin = (fin == '' ? 0 : parseInt(fin.replace(/(\d{2}).(\d{2}).(\d{4})/, '$3$2$1')));

					if (fin < inicio) {
						alert('Fecha final no puede ser menor que la fecha inicial.');
					} else {
						//-- comparamos valores de la columna nCol contra rango de fechas (true = mostrar, false = ocultar]
						oGrid.filterBy(nCol, function (data) {
							var _fecha = parseInt(data.toString().replace(/(\d{2}).(\d{2}).(\d{4})/, '$3$2$1'));
							return (inicio == 0 || _fecha >= inicio && _fecha <= fin);
						});
					}
				} else {
					alert('formato incorrecto utilice dd/mm/aaaa.')
				}
			}
			);

	}
	);


// Inicializacion del menu y submenu
function regsPage(){
	//-- Inicialización de Submenu
	oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
	oSubmenu.attachEvent("onClick", submenuClick);
	oSubmenu.loadXML($('#submenu_placeholder').attr('action'));
		
	//-- Inicialización de Grid
	oGrid = new dhtmlXGridObject('dataGrid');
	oGrid.setHeader("Id,Tipo de comprobante,N&uacutemero aprobaci&oacuten,Fecha aprobaci&oacuten,Vigencia aprobaci&oacuten,Serie,Folio inicial,Cantidad,Folio final");
	oGrid.setInitWidths("50,*,80,150,150,100,115,80,115");
	oGrid.setColAlign("center,left,center,center,center,center,center,center,center");
	oGrid.setSkin("dhx_blue");
	var custom_filter = '<input type=\"text\" id=\"filter_fec_desde_1\" maxlength=\"10\" class=\"custom_date_filter\" />'
	+ ' a <input type=\"text\" id=\"filter_fec_hasta_1\" maxlength=\"10\" class=\"custom_date_filter\" />';
	var custom_filter2 = '<input type=\"text\" id=\"filter_fec_desde_3\" maxlength=\"10\" class=\"custom_date_filter\" />'
	+ ' a <input type=\"text\" id=\"filter_fec_hasta_4\" maxlength=\"10\" class=\"custom_date_filter\" />';
	oGrid.attachHeader("#text_filter,#text_filter,#text_filter," + custom_filter + "," + custom_filter2 + ",#text_filter,#text_filter,#text_filter,#text_filter");
	oGrid.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro');

	oGrid.init();

	loadGridRows();
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGrid.clearAll();
			oGrid.parse(response.data, 'json');
		},
		'json'
		);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

//Función que carga la ventana para agregar un nuevo registro
function addRow(id_option)
{
	$.post(
		oSubmenu.getUserData(id_option, 'action'),
		{},
		function (html) {
			loadJSFile(baseURL + 'agregar/agregar.js');
			oWin = $.newWindow(
			{
				id:'wAddRec', 
				title:'Agregar Aprobaci&oacuten', 
				height:300, 
				width:530, 
				content:html,
				modal:true,
				posx: 120,
				posy: 70,
				onWindowClose: 
				function(){
					loadGridRows();
				}
			}
			);				
		}
		)
}

//Función que carga la ventana para agregar un nuevo registro
function addFile(id_option)
{
	var id = oGrid.getSelectedId();
	if(id != null){
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{
				id : id
			},
			function (html) {
				loadJSFile(baseURL + 'adjuntar/adjuntar.js');
				oWin = $.newWindow(
				{
					id:'wAddFile', 
					title:'Adjuntar documento', 
					height:175, 
					width:650, 
					content:html,
					modal:true,
					posx: 120,
					posy: 70,
					onWindowClose: 
					function(){
						loadGridRows();
					}
				}
				);

				initUploader({
					fileTypes : SWFUPLOAD_fileTypes,
					fileTypesDescription : SWFUPLOAD_fileTypesDescription,
					fileSizeLimit : SWFUPLOAD_fileSizeLimit,
					uploadPath : oSubmenu.getUserData(id_option, 'urlUploaderPath'),
					progressBarWidth : 560,
					onCompletedAction : 'sendForm()',
					idFilenameInput : 'archivo',
					url : oSubmenu.getUserData(id_option, 'urlSwfUploader')
				});
			}
			)
	} else {
		alert('Debe seleccionar un registro.');
	}
}

//Función que carga la ventana para editar un registro
function editRow(id_option)
{
	var id = oGrid.getSelectedId();
	if(id != null){
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{
				id : id
			},
			function (html) {
				loadJSFile(baseURL + 'editar/editar.js');
				oWin = $.newWindow(
				{
					id:'wAddRec', 
					title:'Editar Aprobaci&oacuten', 
					height:300, 
					width:530, 
					content:html,
					modal:true,
					posx: 120,
					posy: 70,
					onWindowClose: 
					function(){
						loadGridRows();
					}
				}
				);				
			}
			);		
	} else {
		alert('Debe seleccionar un registro.');
	}
}

//Funcion que elimina un registro seleccionado por el usuario
function delAprobacion(id_option)
{
	var id = oGrid.getSelectedId();
	if(confirm("\xBFConfirma que desea eliminar este registro?")){
		if (id != null) {
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{
					id : id
				},
				function () {
					successfulOperation("Operacion exitosa!");
					loadGridRows();
				},
				'json'
				)
		} else {
			alert('Debe seleccionar un registro.');
		}
	}
}