/*
* Archivo para manejo general de funciones en el modulo.
*/

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');

		regsPage();
	}
);

// Inicializacion del menu y submenu
function regsPage(){
		//-- Inicialización de Submenu
		oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
		oSubmenu.attachEvent("onClick", submenuClick);
		oSubmenu.loadXML($('#submenu_placeholder').attr('action'));
		
		//-- Inicialización de Grid
		oGrid = new dhtmlXGridObject('dataGrid');
		oGrid.setHeader(
			"Id,Clave,Nombre,Descripci&oacuten,Unidad de Medida,Precio Unitario,impuestos,Tasa IVA, Tasa IEPS,Retencion IVA,Retencion ISR");
		oGrid.setInitWidths("0,70,170,*,70,70,90,60,70,65,65");
		oGrid.setColAlign("left,center,left,left,center,right,right,right,right,right,right");
		oGrid.setSkin("dhx_blue");
		oGrid.attachHeader(",#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");
		oGrid.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');

		oGrid.init();

		loadGridRows();
	}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGrid.clearAll();
			oGrid.parse(response.data, 'json');
		},
		'json'
	);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

// Función que ejecuta la acción de agregar un registro.
function addRow(id_option)
{
	$.post(
            oSubmenu.getUserData(id_option, 'action'),
            {},
            function(html) {
				var viewportWidth = parseInt($('body').innerWidth());
                oWin = $.newWindow(
                    {
                        id: 'wAddRec',
                        title: 'Agregar Producto/Servicio',
                        height: 430,
                        width: 400,
                        content: html,
                        modal: true,
                        posx: Math.max((viewportWidth - 250) / 2, 10),
                        posy: 50
                    }
                );
                loadJSFile(baseURL + 'agregar/agregar.js');
                $(".window-closeButton").hide();
            }
    );
}

// Función que ejecuta la acción de editar un registro.
function editRow(id_option)
{
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				var viewportWidth = parseInt($('body').innerWidth());
				oWin = $.newWindow(
					{
						id:'wEditRec', 
						title:'Modificar Producto/Servicio', 
						height: 430,
                        width: 400,
                        content: html,
                        modal: true,
                        posx: Math.max((viewportWidth - 250) / 2, 10),
                        posy: 60
					}
				);	
				loadJSFile(baseURL + 'editar/editar.js');
				$(".window-closeButton").hide();
			}
		);
	} else {
		alert('Debe seleccionar un registro.');
	}
}

// Función que ejecuta la acción de activar/desactivar un registro.
function activarDesactivar(id_option)
{
	if( confirmOperation() ){
		var id = oGrid.getSelectedId();

		if (id != null) {
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{"id" : id},
				function (response) {
						successfulOperation( response.msg );// simple Alerts!
						loadGridRows();
				},
				'json'
			);
		} else {
			alert('Debe seleccionar un registro.');
		}
	}
}