/*
 * Archivo que carga funciones y eventos del módulo.
 */

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		initCssButtons();
		initInactiveControls();

		$('#descripcion').focus().select();
		$('#btnSave').click(function () { postData(true); });
		$('#btnSaveClose').click(function () { postData(false); });
		$('#btnClose').click(
			function () {
				if(confirm("Los cambios efectuados se perderan, ¿Desea salir?")){
					oWin.close();
				}
			}
		);
			
		$('#checkAll').click(
			function () {
				$('#cnt_permisos :checkbox').each(
					function () {
						$(this).attr('checked', 'checked');
						setState(this);
					}
				);
			}
		);
		
		$('#uncheckAll').click(
			function () {
				$('#cnt_permisos :checkbox').each(
					function () {
						$(this).removeAttr('checked');
						setState(this);
					}
				);
			}
		);
		
		init();
	}
);

// Función que envía la información a guardar.
function postData(keepOpen)
{
	if(!$('#descripcion').hasClass('errorField')){
		if($('input:checked').length>1){
			$.post(
				$('#btnSave').attr('url'),
				$('#frmInput').serializeArray(),
				function (response) {
					if (response.ok) {
						loadGridRows();
						successfulOperation("Operacion Exitosa!");
						if (keepOpen == null || ! keepOpen) oWin.close(true);
					} else {
						$('.error').removeClass('error');
						$(response.error.ids).prev().filter('label').addClass('error');
						alert(response.error.msg);
					}
				},
				'json'
			)
		}else{
			alert('Debe asignar permisos perfil');
		}
	}else{
		if( $('#descripcion').val() == '' ){
			alert('El campo descripcion no puede estar en blanco');
		}else{
			alert('Favor de introducir caracteres validos.');
		}
	}
}

// Inicialización de eventos especificos.
function init()
{
	//-- Inicializamos estado de elementos
	$('#cnt_permisos input').each(
		function() {
			setState(this);
		}
	);

	//-- Agregamos evento a todos los elementos para permisos
	$('#cnt_permisos input').click(
		function() {
			setState(this);
		}
	);
}

// Manipulación de arból
function manipulateTree(el) {
	if($(el).attr('_action') == 'true'){
		$(el).attr('_action','false').attr('src',$(el).attr('_ruta')+'expand.gif');
		$(el).parent().find('ul').hide();
	}else{
		$(el).attr('_action','true').attr('src',$(el).attr('_ruta')+'contract.gif');
		$(el).parent().find('ul').show();
	}
}

// Establece el estatus.
function setState(el) {
	//-- Verifica si elemento esta checado
	var chk = $(el).filter(':checked').length;
	var item = $(el).val();

	if (! chk) { //-- Deshabilitamos y desmarcamos los nodos hijos del elemento seleccionado
		$(el).next().removeClass('checked').addClass('activo');
		
		$('.' + item).removeAttr('checked')
			.attr('disabled', 'disabled')
			.addClass('disabled')
			.removeClass('checked activo');
	} else { //-- Habilitamos UNICAMENTE los nodos hijos del elemento seleccionado
		$(el).next().addClass('checked').removeClass('activo');
		
		var selector = '[class$="' + item + ' disabled"]';
		$(selector).removeAttr('disabled')
			.removeClass('disabled')
			.addClass('activo');
	}
}