/*
 * Archivo para manejo general de funciones en el modulo.
 */

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
        function () {
            //-- URL base del modulo
            baseURL = $('#dataGrid').attr('base_url');

            regsPage();

        }
);

// Inicializacion del menu y submenu
function regsPage() {
    //-- Crea objetos de submenu y grid
    //-- Inicialización de Submenu
    oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
    oSubmenu.attachEvent("onClick", submenuClick);
    oSubmenu.loadXMLString($('#submenu').html());
    oGrid = new dhtmlXGridObject('dataGrid');
    //-- Inicialización de Grid
    oGrid.setHeader("Fecha Alta,Tipo,Serie y Folio,Timbrado,UUID,Cliente,Subtotal,IVA,Ret. IVA,Total,RFC");
    oGrid.setInitWidths("70,95,80,70,95,195,80,80,80,90,95");
    oGrid.setColAlign("center,left,center,center,left,left,right,right,right,right,left");
    oGrid.setSkin("dhx_blue");
    oGrid.attachHeader("#text_filter,#select_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");
    oGrid.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');
    oGrid.attachEvent('onRowSelect', refreshOptions);
    oGrid.init();

    //-- Carga registros al grid
    loadGridRows();
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
    $.post(
            $('#dataGrid').attr('url'),
            {},
            function (response) {
                oGrid.clearAll();
                oGrid.parse(response.data, 'json');
                oGrid.filterByAll();
                refreshOptions();
            },
            'json'
            );
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
    action = oSubmenu.getUserData(id_option, 'script');
    if (action != null && action != '') {
        eval(action);
    } else {
        alert('No action specified for ' + id_option);
    }
}

function refreshOptions() {
    var nRows = oGrid.getRowsNum();
    var id = oGrid.getSelectedId();
    var activa = (id !== null && parseInt(oGrid.getUserData(id, 'activa')) == 1);
    var timbrada = (id !== null && oGrid.cellById(id, 3).getValue() !== '');

    oSubmenu.enableItem('MNCTSC_ACTUALIZAR', true);
    oSubmenu.enableItem('MNCTSC_AGREGAR', true);
    oSubmenu.enableItem('MNCTSC_MODIFICAR', activa && !timbrada);
    oSubmenu.enableItem('MNCTSC_CONSULTAR', id !== null);
    oSubmenu.enableItem('MNCTSC_COPIAR', id !== null);
    oSubmenu.enableItem('MNCTSC_CANCELAR', activa);
    oSubmenu.enableItem('MNCTSC_TIMBRAR', activa && !timbrada);
    oSubmenu.enableItem('MNCTSC_IMPRIMIR', activa && timbrada);
    oSubmenu.enableItem('MNCTSC_ENVIAR', activa && timbrada);
    oSubmenu.enableItem('MNCTSC_DESCARGAXML', timbrada);
    oSubmenu.enableItem('MNCTSC_NOTAS', id !== null);
    oSubmenu.enableItem('MNCTSC_EXPORTAR_EXCEL', nRows > 0);
    oSubmenu.enableItem('MNCTSC_VISTA_PRELIMINAR', nRows > 0);
}

/**
 *Funcion que inicializa la ventana para agregar
 **/
function addRow(id_option) {
    var id_formulario = $("#tipo_formulario").val();

    switch (id_option) {
        case 'MNCTSC_FACTURA':
            var comprobante = '1';
            break;
        case 'MNCTSC_RECIBO_HONORARIO':
            var comprobante = '2';
            break;
        case 'MNCTSC_NOTA_CARGO':
            var comprobante = '3';
            break;
        case 'MNCTSC_ARRENDAMIENTO':
            var comprobante = '5';
            break;
        case 'MNCTSC_NOTA_CREDITO':
            var comprobante = '6';
            break;

    }

    if (id_formulario == 1) {
        //Formulario Basico
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {comprobante: comprobante},
        function (html) {
            var viewportWidth = parseInt($('body').innerWidth());

            loadJSFile(baseURL + 'capturaSimple/agregar/agregar.js');
            oWinFac = $.newWindow(
                    {
                        id: 'wAddRec',
                        title: 'Agregar Comprobante',
                        height: 580,
                        width: 760,
                        content: html,
                        modal: true,
                        posx: Math.max((viewportWidth - 680) / 2, 10),
                        posy: 15,
                        onWindowClose:
                                function () {
                                    loadGridRows();
                                }
                    }
            );
        }
        )
    } else {
        //Formulario Avanzado
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {comprobante: comprobante},
        function (html) {
            var viewportWidth = parseInt($('body').innerWidth());

            loadJSFile(baseURL + 'agregar/agregar.js');
            oWinFac = $.newWindow(
                    {
                        id: 'wAddRec',
                        title: 'Agregar Comprobante',
                        height: 555,
                        width: 960,
                        content: html,
                        modal: true,
                        posx: Math.max((viewportWidth - 960) / 2, 10),
                        posy: 15,
                        onWindowClose:
                                function () {
                                    loadGridRows();
                                }
                    }
            );
        }
        )
    }
}

/**
 *Funcion que inicializa la ventana para editar
 **/
function editRow(id_option)
{
    var id = oGrid.getSelectedId();
    var id_formulario = oGrid.getUserData(id, 'tipo_formato');

    if (id != null) {
        if (id_formulario == 1) {
            //Formulario Basico
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {nId_factura: id, nTipo_formulario: id_formulario},
            function (html) {
                var viewportWidth = parseInt($('body').innerWidth());

                loadJSFile(baseURL + 'capturaSimple/editar/editar.js');
                oWin = $.newWindow(
                        {
                            id: 'wAddRec',
                            title: 'Editar Comprobante',
                            height: 580,
                            width: 760,
                            content: html,
                            modal: true,
                            posx: Math.max((viewportWidth - 680) / 2, 10),
                            posy: 15,
                            onWindowClose:
                                    function () {
                                        loadGridRows();
                                    }
                        }
                );
            }
            );
        } else {
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {
                        nId_factura: id, nTipo_formulario: id_formulario
                    },
            function (html) {
                var viewportWidth = parseInt($('body').innerWidth());
                loadJSFile(baseURL + 'editar/editar.js');
                oWin = $.newWindow(
                        {
                            id: 'wAddRec',
                            title: 'Editar Comprobante',
                            height: 555,
                            width: 960,
                            content: html,
                            modal: true,
                            posx: Math.max((viewportWidth - 960) / 2, 10),
                            posy: 15,
                            onWindowClose:
                                    function () {
                                        loadGridRows();
                                    }
                        }
                );
            }
            );
        }
    } else {
        alert('Debe seleccionar un registro.');
    }
}

/**
 *Funcion que inicializa la ventana para consultar
 **/
function consultRow(id_option) {
    var id = oGrid.getSelectedId();
    var id_formulario = oGrid.getUserData(id, 'tipo_formato');
    if (id != null) {
        if (id_formulario == 1) {
            //Formulario Basico
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {nId_factura: id, nTipo_formulario: id_formulario},
            function (html) {
                var viewportWidth = parseInt($('body').innerWidth());

                loadJSFile(baseURL + 'capturaSimple/consultar/consultar.js');
                oWin = $.newWindow(
                        {
                            id: 'wAddRec',
                            title: 'Consultar Comprobante',
                            height: 460,
                            width: 760,
                            content: html,
                            modal: true,
                            posx: Math.max((viewportWidth - 680) / 2, 10),
                            posy: 15,
                            onWindowClose:
                                    function () {
                                        loadGridRows();
                                    }
                        }
                );
            }
            );
        } else {
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {
                        nId_factura: id, nTipo_formulario: id_formulario
                    },
            function (html) {
                var viewportWidth = parseInt($('body').innerWidth());
                loadJSFile(baseURL + 'consultar/consultar.js');
                oWin = $.newWindow(
                        {
                            id: 'wShowRec',
                            title: 'Consultar Comprobante',
                            height: 555,
                            width: 970,
                            content: html,
                            modal: true,
                            posx: Math.max((viewportWidth - 970) / 2, 10),
                            posy: 15,
                            onWindowClose:
                                    function () {
                                        loadGridRows();
                                    }
                        }
                );
            }
            );
        }
    } else {
        alert('Debe seleccionar un registro.');
    }
}

/**
 *Funcion que postea el id del registro a copiar
 **/
function copyRow(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        if (confirm("\xBFConfirma que desea copiar este registro?")) {
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {
                        nId_factura: id
                    },
            function (response) {
                successfulOperation(response.msg);
                loadGridRows();
            },
                    'json'
                    )
        }
    } else {
        alert('Debe seleccionar un registro.');
    }
}
/**
 *Funcion que postea el id del registro a timbrar
 **/
function timbrarFactura(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        if (confirm("\xBFConfirma que desea generar el timbrado?")) {
            oSubmenu.enableItem('MNCTSC_TIMBRAR', 0);
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {
                        nId_factura: id
                    },
            function (data) {
                alert(data.msg);
                loadGridRows();
                oSubmenu.enableItem('MNCTSC_TIMBRAR', 1);
            },
                    'json'
                    )
        }
    } else {
        alert('Debe seleccionar un registro.');
    }
}

function cancelarFactura(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        if (confirm("\xBFConfirma que desea cancelar esta factura?")) {
            $.post(
                    oSubmenu.getUserData(id_option, 'action'),
                    {
                        nId_factura: id
                    },
            function (response) {
                successfulOperation(response.msg);
                loadGridRows();
            },
                    'json'
                    )
        }
    } else {
        alert('Debe seleccionar un registro.');
    }
}

function enviarFactura(id_option) {
    var id = oGrid.getSelectedId();

    if (id != null) {
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {
                    nId_factura: id
                },
        function (html) {
            $.post(
                    $('#dataGrid').attr('action'),
                    {
                        nId_factura: id
                    },
            function (response) {
                if (response.timbrada == '1') {
                    loadJSFile(baseURL + 'enviar/enviar.js');
                    oWin = $.newWindow({
                        id: 'wShowRec',
                        title: 'Envio de Comprobante',
                        height: 135,
                        width: 550,
                        content: html,
                        modal: true,
                        posx: 120,
                        posy: 70,
                        onWindowClose:
                                function () {
                                }
                    });

                } else {
                    alert('La factura debe ser timbrada antes de enviarla.');
                }
            },
                    'json'
                    )
        }
        );

    } else {
        alert('Debe seleccionar un registro.');
    }
}

function notasFactura(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {
                    nId_factura: id
                },
        function (html) {
            loadJSFile(baseURL + 'notas/notas.js');
            oWin = $.newWindow(
                    {
                        id: 'wShowRec',
                        title: 'Notas Comprobante',
                        height: 390,
                        width: 610,
                        content: html,
                        modal: true,
                        posx: 120,
                        posy: 70,
                        onWindowClose:
                                function () {
                                    loadGridRows();
                                }
                    }
            );
        }
        );
    } else {
        alert('Debe seleccionar un registro.');
    }
}

function exportarExcel(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        oGrid.toExcel('codebase/grid-excel-php/generate.php')
    } else {
        alert('Debe seleccionar un registro.');
    }
}

function imprimirFactura(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {nId_factura: id},
        function (response) {
            if (response.timbrada == '1') {
                var viewportHeight = parseInt($('body').innerHeight());

                oWin = $.newWindow(
                        {
                            id: 'wInvoiceView',
                            title: 'Impresi&oacute;n de Comprobante Fiscal',
                            height: Math.max(viewportHeight - 74, 500),
                            width: 930,
                            content: response.html,
                            modal: true,
                            posx: 15,
                            posy: 15
                        }
                );
            } else {
                alert('La factura debe ser timbrada antes de imprimir.');
            }
        },
                'json'
                );
    } else {
        alert('Debe seleccionar un registro a imprimir.');
    }
}

function preliminar(id_option) {
    var id = oGrid.getSelectedId();
    if (id != null) {
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {nId_factura: id},
        function (response) {
            var viewportHeight = parseInt($('body').innerHeight());

            oWin = $.newWindow(
                    {
                        id: 'wInvoiceView',
                        title: 'Vista preliminar de Comprobante Fiscal',
                        height: Math.max(viewportHeight - 74, 500),
                        width: 930,
                        content: response.html,
                        modal: true,
                        posx: 15,
                        posy: 15
                    }
            );
        },
                'json'
                );
    } else {
        alert('Debe seleccionar un registro a imprimir.');
    }
}

function descargarXML(id_option) {
    var id = oGrid.getSelectedId();

    if (id != null) {
        $.post(
                oSubmenu.getUserData(id_option, 'action'),
                {'id_factura': id},
        function (response) {
            window.open(response.url, '_blank');
        },
                'json'
                );
    } else {
        alert('Debe seleccionar un registro.');
    }
}