<?php

/*
 * Genera el Pdf de la factura mediante su id.
 * 
 * @author Mario Cruz.
 */
require_once(FS_FRAMEWORK . 'mpdf/mpdf.php');
//require_once(FS_FRAMEWORK . 'variables.php');
//require_once(FS_FRAMEWORK . 'classes/Template.php');
require_once(FS_CLASSES . 'FacturasDAO.php');
require_once(FS_CLASSES . 'ConfiguracionCuentaDAO.php');
require_once(FS_CLASSES . 'PlantillasDAO.php');
require_once(FS_CLASSES . 'Municipios.php');
require_once(FS_CLASSES . 'functions.php');

$cta = new ConfiguracionCuentaDAO();
$mun = new Municipios();
$fac = new FacturasDAO();
$oPtlla = new PlantillasDAO();
$result = array();

$id_factura = $_REQUEST['nId_factura'];
$infoFac = $fac->obtenerInformacionFactura($id_factura);
$infoEmisor = reset($cta->cargaConfiguracionCuenta($infoFac['id_usuario']));
$factura = $fac->get_infoImprimirFactura($id_factura);
$res = $fac->getStatus($id_factura);

$logotipo = ($factura['logotipo'] != '' ? FS_DATA_LOGOTIPOS . $factura['logotipo'] : '');

if ($res['timbrada']) {

	$cbb = file_put_contents(FS_TEMP . "cbb" . $id_factura . ".jpg", base64_decode($factura['qrcode']));
	$cbb = '<img class="qr" src="' . FS_TEMP . 'cbb' . $id_factura . '.jpg" />';

	$mpdf = new mPDF('es-MX', 'Letter');
	$xml = new DOMDocument('1.0', 'utf-8');
	$xml->formatOutput = true;
	$xml->loadXML(utf8_encode($factura['xml']));

	//-- Informacion del comprobante
	$comprobante = $xml->getElementsByTagName('Comprobante')->item(0);
	$certificado_emisor = $comprobante->getAttribute('noCertificado');
	$serie = $comprobante->getAttribute('serie');
	$folio = $comprobante->getAttribute('folio');
	$factura_fecha = $comprobante->getAttribute('fecha');
	$factura_localidad = $comprobante->getAttribute('LugarExpedicion');
	$metodo_pago = $comprobante->getAttribute('metodoDePago');
	$forma_pago = $comprobante->getAttribute('formaDePago');
	$factura_total = $comprobante->getAttribute('total');

	//Informacion del emisor
	$emisor = $comprobante->getElementsByTagName('Emisor')->item(0);
	$emisor_nombre = $emisor->getAttribute('nombre');
	$emisor_rfc = $emisor->getAttribute('rfc');
	$domicilio_emisor = $emisor->getElementsByTagName('DomicilioFiscal')->item(0);

	//-- Domicilio fiscal del emisor
	$emisor_direccion = $domicilio_emisor->getAttribute('calle') . ' '
			. $domicilio_emisor->getAttribute('noExterior') . ' '
			. $domicilio_emisor->getAttribute('noInterior');
	$emisor_colonia = $domicilio_emisor->getAttribute('colonia');
	$emisor_localidad = $domicilio_emisor->getAttribute('localidad');
	$emisor_ciudad = $domicilio_emisor->getAttribute('municipio') . ', '
			. $domicilio_emisor->getAttribute('estado');
	$emisor_codigo_postal = $domicilio_emisor->getAttribute('codigoPostal');

	//-- Regimen fiscal del emisor
	$regimen_emisor = $emisor->getElementsByTagName('RegimenFiscal')->item(0);
	$emisor_regimen = $regimen_emisor->getAttribute('Regimen');

	//Informacion del Receptor
	$receptor = $comprobante->getElementsByTagName('Receptor')->item(0);
	$receptor_rfc = $receptor->getAttribute('rfc');
	$receptor_nombre = $receptor->getAttribute('nombre');

	//-- Domicilio del receptor
	$domicilio_receptor = $receptor->getElementsByTagName('Domicilio')->item(0);
	$receptor_direccion = $domicilio_receptor->getAttribute('calle') . ' '
			. $domicilio_receptor->getAttribute('noExterior') . ' '
			. $domicilio_receptor->getAttribute('noInterior');
	$receptor_colonia = $domicilio_receptor->getAttribute('colonia');
	$receptor_ciudad = $domicilio_receptor->getAttribute('municipio') . ', '
			. $domicilio_receptor->getAttribute('estado');
	$receptor_localidad = $domicilio_receptor->getAttribute('localidad');
	$receptor_codigo_postal = $domicilio_receptor->getAttribute('codigoPostal');

	//-- Informacion del Complemento de timbrado fiscal
	$complemento = $comprobante->getElementsByTagName('Complemento')->item(0);
	$timbre = $complemento->getElementsByTagName('TimbreFiscalDigital')->item(0);
	$certificado_sat = $timbre->getAttribute('noCertificadoSAT');
	$sello_digital_emisor = $timbre->getAttribute('selloCFD');
	$sello_digital_sat = $timbre->getAttribute('selloSAT');
	$fecha_timbrado = $timbre->getAttribute('FechaTimbrado');
	$uuid = $timbre->getAttribute('UUID');

	//-- Informacion de Impuestos
	$impuestos = $comprobante->getElementsByTagName('Impuestos');
	$retencion_iva = 0;
	$retencion_isr = 0;
	$retencion_ieps = 0;
	$ivas_factura[0] = 0; //-- Inicializa arreglo de IVAS con tasa 0

	if ($impuestos->length > 0) {
		$retenciones = $impuestos->item(0)->getElementsByTagName('Retencion');

		if ($retenciones->length > 0) {
			foreach ($retenciones as $tr) {
				if ($tr->getAttribute('impuesto') == 'IVA') {
					$retencion_iva = $tr->getAttribute('importe');
				} else if ($tr->getAttribute('impuesto') == 'ISR'){
					$retencion_isr = $tr->getAttribute('importe');
				}
			}
		}

		$traslados = $impuestos->item(0)->getElementsByTagName('Traslado');

		if ($traslados->length > 0) {
			foreach ($traslados as $tr) {
				if ($tr->getAttribute('impuesto') == 'IVA') {
					$_tasa = floatval($tr->getAttribute('tasa'));
					$ivas_factura[$_tasa] = floatval($tr->getAttribute('importe'));
				}
				
				if ($tr->getAttribute('impuesto') == 'IEPS') {
					$tasa_ieps = floatval($tr->getAttribute('tasa'));
					$ieps_factura[$tasa_ieps] = floatval($tr->getAttribute('importe'));
				}
			}

			krsort($ivas_factura, SORT_NUMERIC);
		}
	}
	//-- determinacion de IVAs de Factura
	$factura_iva = reset($ivas_factura);
	$factura_tasa_iva = reset(array_keys($ivas_factura));

	$total_letra = monedaATexto($factura_total);
	
//	$oTpl->load(FS_LISTADO_FACTURAS . 'imprimir/factura.html');
	$plantilla = reset($oPtlla->plantillaComprobante($infoFac['id_usuario'], $infoFac['tipo_comprobante']));

	$oTpl->loadFromString($plantilla['html']);

	//-- Procesa Información de Conceptos
	$factura_subtotal = 0;
	$iva_exento = '0';
	$rowsConceptos = $fac->listarConceptos($id_factura);
	if ($oTpl->getBlock('DETALLE_CONCEPTOS')) {
		$sizeArray = count($rowsConceptos);
		for ($i = 0; $i < $sizeArray; $i++) {
			if($rowsConceptos[$i]['iva_exento'] == '1'){
				$iva_exento = '1';
			}
			$factura_subtotal += $rowsConceptos[$i]['cantidad'] * $rowsConceptos[$i]['precio_unitario'];
			$descri = str_replace(chr(13) . chr(10), '<br>', $rowsConceptos[$i]['concepto']);
			$oTpl->setVar(
					array(
						'CANTIDAD' => $rowsConceptos[$i]['cantidad'],
						'UNIDAD_MEDIDA' => $rowsConceptos[$i]['unidad'],
						'DESCRIPCION_CONCEPTO' => $descri,
						'PRECIO_UNITARIO' => pesos($rowsConceptos[$i]['precio_unitario']),
						'IMPORTE_CONCEPTO' => pesos($rowsConceptos[$i]['cantidad'] * $rowsConceptos[$i]['precio_unitario'])
					)
			);
			$oTpl->appendBlock();
		}
		$oTpl->putBlock('DETALLE_CONCEPTOS');
	}
	
	$oTpl->setVar(
			array(
				'EMISOR_NOMBRE' => $emisor_nombre,
				'EMISOR_DIRECCION' => $emisor_direccion,
				'EMISOR_COLONIA' => $emisor_colonia,
				'EMISOR_CIUDAD' => $emisor_ciudad,
				'EMISOR_CODIGO_POSTAL' => $emisor_codigo_postal,
				'EMISOR_TELEFONO' => $infoEmisor['telefonos'],
				'EMISOR_RFC' => $emisor_rfc,
				'EMISOR_REGIMEN' => $emisor_regimen,
				'RECEPTOR_RAZON_SOCIAL' => $receptor_nombre,
				'RECEPTOR_DIRECCION' => $receptor_direccion,
				'RECEPTOR_COLONIA' => $receptor_colonia,
				'RECEPTOR_CIUDAD' => $receptor_ciudad,
				'RECEPTOR_CODIGO_POSTAL' => $receptor_codigo_postal,
				'RECEPTOR_RFC' => $receptor_rfc,
				'FACTURA_FOLIO' => trim($serie . ' ' . $folio),
				'FACTURA_FECHA' => $factura_fecha,
				'FACTURA_LUGAR_EMISION' => $factura_localidad,
				'METODO_PAGO' => $metodo_pago,
				'FORMA_PAGO' => $forma_pago,
				'ULTIMOS_DIGITOS' => $factura['digitos_tarjeta'],
				'FACTURA_CONDICIONES' => '',
				'FACTURA_CONCEPTOS' => $conceptos_html,
				'FACTURA_SUBTOTAL' => pesos($factura_subtotal),
				'FACTURA_IVA' => pesos($factura_iva),
				'RETENCION_IVA' => pesos($retencion_iva),
				'RETENCION_ISR' => pesos($retencion_isr),
				'TASA_IVA' => $factura_tasa_iva,
				'FACTURA_TOTAL' => pesos($factura_total),
				'CERTIFICADO_SAT' => $certificado_sat,
				'CERTIFICADO_EMISOR' => $certificado_emisor,
				'FECHA_CERTIFICADO' => $fecha_timbrado,
				'FOLIO_FISCAL' => $uuid,
				'CADENA_ORIGINAL' => $factura['cadena_timbre'],
				'SELLO_DIGITAL_EMISOR' => $sello_digital_emisor,
				'SELLO_DIGITAL_SAT' => $sello_digital_sat,
				'IMG_CCB' => $cbb,
				'TOTAL_LETRA' => $total_letra,
				'LOGOTIPO' => $logotipo,
				'LOGO_X' => $infoEmisor['pos_x'] . 'px',
				'LOGO_Y' => $infoEmisor['pos_y'] . 'px',
				'LOGO_W' => $infoEmisor['ancho'] . 'px',
				'LOGO_H' => $infoEmisor['alto'] . 'px',
				'EMISOR_X' => $infoEmisor['margen_datos_emisor'] . 'px',
				'IMAGENES_PLANTILLAS' => FS_IMAGENES_PLANTILLAS
			)
	);

	//-- Elimina block de logotipo si no se ha configurado la imagen
	$oTpl->removeBlock('LOGOTIPO', empty($logotipo));

	//-- Procesa Información de Impuestos Locales
	$implocal = $complemento->getElementsByTagName('ImpuestosLocales');
	if ($oTpl->getBlock('RETENCION_IMP_LOCAL')) {
		foreach ($implocal as $pr) {
			$retlocal = $pr->getElementsByTagName('RetencionesLocales');
			foreach ($retlocal as $rs) {
				$oTpl->setVar(array('DESCRIPCION_IMP_LOCAL' => "Retención ".$rs->getAttribute('ImpLocRetenido')));
				$oTpl->appendBlock();
			}
		}
		$oTpl->putBlock('RETENCION_IMP_LOCAL');
	}
	
	if ($oTpl->getBlock('RETENCION_IMP_LOCAL_IMPORTE')) {
		foreach ($implocal as $pr) {
			$retlocal = $pr->getElementsByTagName('RetencionesLocales');
			foreach ($retlocal as $rs) {
				$oTpl->setVar(array('IMPORTE_IMP_LOCAL' => pesos($rs->getAttribute('Importe'))));
				$oTpl->appendBlock();
			}
		}
		$oTpl->putBlock('RETENCION_IMP_LOCAL_IMPORTE');
	}
	
	
	//-- Validacion de Block para Retencion
	$oTpl->removeBlock('RETENCION_IVA_LABEL', $retencion_iva == 0);
	$oTpl->removeBlock('RETENCION_LEYENDA', $retencion_iva == 0);
	$oTpl->removeBlock('RETENCION_IVA_VALUE', $retencion_iva == 0);

	//-- Procesamiento de bloque de IVA's
	if ($oTpl->getBlock('DETALLE_IVAS_LABEL')) {
		foreach ($ivas_factura as $k => $v) {
			if ($k > 0) {
				$oTpl->setVar(array('TASAIVA' => $k));
				$oTpl->appendBlock();
			}
		}

		$oTpl->putBlock('DETALLE_IVAS_LABEL');
	}
	
	if ($oTpl->getBlock('DETALLE_IVA_EXENTO')) {
		if($iva_exento == '1'){
			$oTpl->appendBlock();
		}
		$oTpl->putBlock('DETALLE_IVA_EXENTO');
	}
	if ($oTpl->getBlock('DETALLE_IVA_EXENTO_VALUE')) {
		if($iva_exento == '1'){
			$oTpl->appendBlock();
		}
		$oTpl->putBlock('DETALLE_IVA_EXENTO_VALUE');
	}
	
//-- Procesamiento de bloque de IVA's
	if ($oTpl->getBlock('DETALLE_IEPS_LABEL')) {
		if(!empty($ieps_factura)){
			foreach ($ieps_factura as $k => $v) {
				if ($k > 0) {
					$oTpl->setVar(array('TASAIEPS' => $k));
					$oTpl->appendBlock();
				}
			}
		}
		$oTpl->putBlock('DETALLE_IEPS_LABEL');
	}
	
	if ($oTpl->getBlock('DETALLE_IEPS_VALUE')) {
		if(!empty($ieps_factura)){
			foreach ($ieps_factura as $k => $v) {
				if ($k > 0) {
					$oTpl->setVar(array('IMPORTEIEPS' => pesos($v)));
					$oTpl->appendBlock();
				}
			}
		}
		$oTpl->putBlock('DETALLE_IEPS_VALUE');
	}
	
	if ($oTpl->getBlock('DETALLE_IVAS_VALUE')) {
		foreach ($ivas_factura as $k => $v) {
			if ($k > 0) {
				$oTpl->setVar(array('IMPORTEIVA' => pesos($v)));
				$oTpl->appendBlock();
			}
		}

		$oTpl->putBlock('DETALLE_IVAS_VALUE');
	}
	
	//-- Extraemos plantilla procesada
	$strPDF = utf8_decode($oTpl->publish(true));

//	$css = file_get_contents(FS_LISTADO_FACTURAS . 'imprimir/recibo.css');
	$mpdf->WriteHTML($plantilla['css'], 1);
	$mpdf->WriteHTML($strPDF, 0);
	if (!file_exists(FS_TEMP))
		mkdir(FS_TEMP);

	$name = 'factura_' . trim($serie . $folio) . '.pdf';
	$mpdf->Output(FS_TEMP . $name, 'F');

	$oTpl->load(FS_LISTADO_FACTURAS . 'imprimir/invoiceView.html');
	$oTpl->setVar(array('DOCUMENT_SOURCE' => WS_FRAMEWORK . 'downloadPdf.php?pdf=' . $name));

	$result['timbrada'] = 1;
	$result['html'] = $oTpl->publish(true);
	$result['name_file'] = $name;
}else {
	$result['timbrada'] = 0;
}

if (isset($enviar)) {
	return json_encode($result);
} else {
	unlink(FS_TEMP . "cbb" . $id_factura . ".jpg");
	echo json_encode($result);
}
?>