<?php

/**
 * Clase DAO para el manejo de los Folios y Series
 * @author Carlos Almaguer <calmaguer@softnet.com.mx>
 */
require FS_CLASSES . "Folio.php";

class FolioDAO extends Folio {

	/**
	 * Obtiene un arreglo con la lista de los paquetes con estatus activo
	 * @return array
	 */
	public function foliosCuenta($id_usuario = 0) {
		$_sql = "stp_foliosCuenta(:id)";

		return $this->executeSP($_sql, array('id' => $id_usuario));
	}

	public function updateFoliosCuenta($data) {
		$series = array_pop($data);
		
		if (count($series) > 0) {
			$_sql = "
				stp_updFolioCuenta(
					:id_usuario,
					:id_tipo_comprobante,
					:serie,
					:folio
				)
			";
			
			foreach($series AS $serie) {
				if ($serie['serie'] != '' && $serie['folio'] != '') {
					$serie += $data;
					$serie['folio'] = empty($serie['folio']) ? 0 : $serie['folio'];
					$this->executeSP($_sql, $serie);
				}
			}
		}
	}
	
	public function asigaFolioComprobante($id_usuario, $id_tipo_comprobante) {
		$values = array(
			'id_usuario' => $id_usuario,
			'id_tipo_comprobante' => $id_tipo_comprobante
		);
		$sql = "stp_asignaFolioCuenta(:id_usuario, :id_tipo_comprobante)";
		
		return reset($this->executeSP($sql, $values));
	}
}

?>