<?php

require_once ('RegimenFiscal.php');

/**
 * @author Angel
 * @version 1.0
 * @created 05-ago-2013 05:12:44 p.m.
 */
class RegimenFiscalDAO extends RegimenFiscal {

    /**
     * Lista todos los registros
     * @param $id
     */
    public function listarRegimenFiscal( $id = null ) {
        $values['id'] = $id;
        return $this->executeSP("stp_RegimenesFiscales(:id)", $values);
    }

    /**
     * Valida la información
     * @param array $values
     * @return array
     */
    public function validateData( $values ) {
        $spName = "stp_validaRegimenFiscal(:id , :descripcion)";
        return $this->executeSP($spName, $values);
    }

    /**
     * Inserta un nuevo registro.
     * @param array $values
     * @return array
     */
    public function insertRegimenFiscal( $values ) {
        $spName = "stp_insRegimenFiscal(:descripcion,:activo)";
        return $this->executeSP($spName, $values);
    }

    /**
     * Actualiza la información de un registro.
     * @param data
     */
    public function updateRegimenFiscal( $values ) {
        $spName = "stp_updRegimenFiscal(:id,:descripcion,:activo)";
        return $this->executeSP($spName, $values);
    }

    /**
     * Actualiza el estatus de un registro
     * @param array $values
     * @return array
     */
    public function statusRegimenFiscal( $values ) {
        $spName = "stp_statusRegimenFiscal(:id,:activo)";
        return $this->executeSP($spName, $values);
    }

}

?>