<?php

/**
 * Clase para Nominas Manuales.
 * @author Mario Cruz
 */
require_once('./framework/classes/DBConnector.php');
require_once(FS_CLASSES . 'FacturasDAO.php');
require_once(FS_CLASSES . 'Municipios.php');
require_once(FS_CLASSES . 'Estados.php');
require_once(FS_CLASSES . 'UsuariosDAO.php');
require_once(FS_CLASSES . 'ClienteDAO.php');
require_once(FS_CLASSES . 'SucursalDAO.php');

class genera_xml extends DBConnector {

	public function xmlNomina($id_nomina) {
		$return = array();
		$mun = new Municipios();
		$est = new Estados();
		$nom = new NominaDAO();
		$emi = new UsuariosDAO();
		$rec = new ClienteDAO();
		$suc = new SucursalDAO();


		$info_nomina = $nom->obtenerInformacionNomina($id_nomina);
		
		$info_nomina['config_usuario'] = $nom->obtenerConfigUsuario();


		$info_nomina['emisor'] = $emi->recuperarUsuario($info_nomina['id_usuario']);
		$info_nomina['receptor'] = $nom->recuperarEmpleado($info_nomina['id_empleado']);
		
		$id_sucursal = 0;
		$info_nomina['sucursal'] = $suc->recuperarSucursal($id_sucursal, $info_nomina['id_usuario']);

		$info_nomina['percepciones'] = $nom->listPercepciones($id_nomina);

		$concepto = $info_nomina['total_gravado_per'] + $info_nomina['total_exento_per'];
		$subtotal = $concepto;

		$info_nomina['deducciones'] = $nom->listDeducciones($id_nomina);

		$deducciones = $info_nomina['deducciones'];
		$cant = count($deducciones);
		$descuento = '0.0';
		$total_impuestos = 0;
		for ($i = 0; $i < $cant; $i++) {
			if ($deducciones[$i]['tipo_deduccion'] != '002') {
				$descuento += $deducciones[$i]['importe_gravado'] + $deducciones[$i]['importe_exento'];
			} else {
				$total_impuestos += $deducciones[$i]['importe_gravado'] + $deducciones[$i]['importe_exento'];
				
			}
		}
		$id_sucursal = 0;
		$info_nomina['sucursal'] = $suc->recuperarSucursal($id_sucursal, $info_nomina['id_usuario']);



		//====================================//
		//   Generacion de XML para Sellado   //
		//====================================//
		$pais = utf8_decode("Mexico");
		$domXML = new DOMDocument('1.0', 'UTF-8');
		$domXML->formatOutput = true;
		
		$root = $domXML->createElement('cfdi:Comprobante');
		$root = $domXML->appendChild($root);
		//-- Atributos de Comprobante
		$this->addAttr($domXML, $root, 'xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
		$this->addAttr($domXML, $root, 'xmlns:nomina', 'http://www.sat.gob.mx/nomina');
		$this->addAttr($domXML, $root, 'xmlns:cfdi', 'http://www.sat.gob.mx/cfd/3');
		$this->addAttr($domXML, $root, 'version', '3.2');
		
		$this->addAttr($domXML, $root, 'serie', $info_nomina['serie']);
		$this->addAttr($domXML, $root, 'folio', $info_nomina['folio']);
		
		$this->addAttr($domXML, $root, 'xsi:schemaLocation', 'http://www.sat.gob.mx/cfd/3 '
				. 'http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv32.xsd '
				. 'http://www.sat.gob.mx/nomina '
				. 'http://www.sat.gob.mx/sitio_internet/cfd/nomina/nomina11.xsd ');

		
		
		
		//EMISOR
		$emisor = $info_nomina['emisor'];
		//-- Atributos de Emisor
		$emisor_tag = $domXML->createElement('cfdi:Emisor');
		$root->appendChild($emisor_tag);
		$this->addAttr($domXML, $emisor_tag, 'rfc', $emisor['rfc']);
		$this->addAttr($domXML, $emisor_tag, 'nombre', $emisor['nombre']);

		//-- Domicilio Fiscal
		$dom_fiscal = $domXML->createElement('cfdi:DomicilioFiscal');
		$emisor_tag->appendChild($dom_fiscal);
		$this->addAttr($domXML, $dom_fiscal, 'calle', $emisor['calle']);
		$this->addAttr($domXML, $dom_fiscal, 'noExterior', $emisor['num_ext']);
		if (!empty($emisor['num_int'])) {
			$this->addAttr($domXML, $dom_fiscal, 'noInterior', $emisor['num_int']);
		}
		
		$this->addAttr($domXML, $dom_fiscal, 'colonia', $emisor['colonia']);
		$this->addAttr($domXML, $dom_fiscal, 'localidad', $emisor['municipio']);
		$this->addAttr($domXML, $dom_fiscal, 'referencia', '0');
		$this->addAttr($domXML, $dom_fiscal, 'municipio', $emisor['municipio']);
		$this->addAttr($domXML, $dom_fiscal, 'estado', $emisor['estado']);
		$this->addAttr($domXML, $dom_fiscal, 'pais', $pais);
		$this->addAttr($domXML, $dom_fiscal, 'codigoPostal', $emisor['codigo_postal']);
		
		//-- Datos de Expedicion
		$expedido = $domXML->createElement('cfdi:ExpedidoEn');
		$emisor_tag->appendChild($expedido);
		$this->addAttr($domXML, $expedido, 'calle', $emisor['calle']);
		$this->addAttr($domXML, $expedido, 'noExterior', $emisor['num_ext']);
		
		if (!empty($emisor['num_int'])) {
			$this->addAttr($domXML, $expedido, 'noInterior', $emisor['num_int']);
		}
		$this->addAttr($domXML, $expedido, 'colonia', $emisor['colonia']);
		$this->addAttr($domXML, $expedido, 'localidad', $emisor['municipio']);
		$this->addAttr($domXML, $expedido, 'referencia', '0');
		$this->addAttr($domXML, $expedido, 'municipio', $emisor['municipio']);
		$this->addAttr($domXML, $expedido, 'estado', $emisor['estado']);
		$this->addAttr($domXML, $expedido, 'pais', $pais);
		$this->addAttr($domXML, $expedido, 'codigoPostal', $emisor['codigo_postal']);
		
		//-- Datos de Regimen Fiscal
		$regimen = $domXML->createElement('cfdi:RegimenFiscal');
		$emisor_tag->appendChild($regimen);
		$this->addAttr($domXML, $regimen, 'Regimen', $emisor['regimen_fiscal']);

		//RECEPTOR
		$receptor = $info_nomina['receptor'];
		//-- Datos del Receptor
		$receptor_tag = $domXML->createElement('cfdi:Receptor');
		$root->appendChild($receptor_tag);
		$this->addAttr($domXML, $receptor_tag, 'rfc', $receptor['rfc']);
		$this->addAttr($domXML, $receptor_tag, 'nombre', $receptor['nombre']);

		
	
		/*
		//-- Datos del Domicilio del Receptor
		$domicilio = $domXML->createElement('cfdi:Domicilio');
		$receptor_tag->appendChild($domicilio);
		 if(!empty($receptor['calle'])){
			$this->addAttr($domXML, $domicilio, 'calle', $receptor['calle']);
		}
		if(!empty($receptor['num_ext'])){
			$this->addAttr($domXML, $domicilio, 'noExterior', $receptor['num_ext']);
		}
		if (!empty($receptor['num_int'])) {
			$this->addAttr($domXML, $domicilio, 'noInterior', $receptor['num_int']);
		}
		if (!empty($receptor['colonia'])) {
			$this->addAttr($domXML, $domicilio, 'colonia', $receptor['colonia']);
		}
		if (!empty($receptor['colonia'])) {
			$this->addAttr($domXML, $domicilio, 'localidad', $receptor['municipio']);
		}
		$this->addAttr($domXML, $domicilio, 'referencia', '0');
		$this->addAttr($domXML, $domicilio, 'municipio', $receptor['municipio']);
		$this->addAttr($domXML, $domicilio, 'estado', $receptor['estado']);
		$this->addAttr($domXML, $domicilio, 'codigoPostal', $receptor['codigo_postal']);
		
		$this->addAttr($domXML, $domicilio, 'pais', $pais);
		*/
		
		$this->addAttr($domXML, $root, 'fecha', date('Y-m-d') . "T" . date('H:i:s'));
		$this->addAttr($domXML, $root, 'sello', '');
		$this->addAttr($domXML, $root, 'formaDePago', utf8_decode('Pago en una sola exhibición')); // @TODO cambiar a variable
		$this->addAttr($domXML, $root, 'noCertificado', '');
		$this->addAttr($domXML, $root, 'certificado', '');

		//SUBTOTAL
		$this->addAttr($domXML, $root, 'subTotal', $subtotal);

		//DESCUENTO
		if($descuento > 0){
			$this->addAttr($domXML, $root, 'descuento', $descuento);
		}
		//MOTIVO DESCUENTO
		$this->addAttr($domXML, $root, 'motivoDescuento', utf8_decode("Deducciones nómina"));

		//TOTAL
		$total = $subtotal - $descuento - $total_impuestos;
		$this->addAttr($domXML, $root, 'total', $total);

		
		//TIPO DE COMPROBANTE
		$this->addAttr($domXML, $root, 'tipoDeComprobante', 'egreso');
		
		//METODO DE PAGO
		$this->addAttr($domXML, $root, 'metodoDePago', "Transferencia Electronica"); // @TODO cambiar por variable

		//LUGAR EXPEDICION
		$this->addAttr($domXML, $root, 'LugarExpedicion', ($info_nomina['sucursal']['municipio'] . ", " . $info_nomina['sucursal']['estado']));

		

		//-- Conceptos de la Factura
		$conceptos = $domXML->createElement('cfdi:Conceptos');
		$root->appendChild($conceptos);

		$arrayImpuestos = array();

		$list_concepto = $domXML->createElement('cfdi:Concepto');
		$conceptos->appendChild($list_concepto);

		$this->addAttr($domXML, $list_concepto, 'cantidad', 1);
		$this->addAttr($domXML, $list_concepto, 'unidad', "Servicio");
		$this->addAttr($domXML, $list_concepto, 'descripcion', "Pago de nomina");
		$this->addAttr($domXML, $list_concepto, 'valorUnitario', $concepto);
		$this->addAttr($domXML, $list_concepto, 'importe', $concepto);

		//IMPUESTOS
		$nodo_impuestos = $domXML->createElement('cfdi:Impuestos');
		$root->appendChild($nodo_impuestos);
		
		$this->addAttr($domXML, $nodo_impuestos, 'totalImpuestosRetenidos', number_format($total_impuestos,2,".",""));
//		$this->addAttr($domXML, $nodo_impuestos, 'totalImpuestosTrasladados', number_format(0,2,".","")); // @TODO agregar variable 

		//RETENCIONES
		$retenciones = $domXML->createElement('cfdi:Retenciones');
		$nodo_impuestos->appendChild($retenciones);
		
		$retencion = $domXML->createElement('cfdi:Retencion');
		$retenciones->appendChild($retencion);
		$this->addAttr($domXML, $retencion, 'importe', number_format($total_impuestos,2,".",""));
		$this->addAttr($domXML, $retencion, 'impuesto', "ISR");

//var_dump(number_format($total_impuestos,2,".",""));
		//COMPLEMENTO
		$complemento = $domXML->createElement('cfdi:Complemento');
		$root->appendChild($complemento);

		
		
		$nomina = $domXML->createElement('nomina:Nomina');
		$complemento->appendChild($nomina);
		
		//Calculo antiguedad por semanas
		$c = strtotime(date("Y-m-d")) - strtotime($info_nomina['receptor']['fecha_contrato']); 
		$antiguedad = round($c / 604800);
		
		
		$this->addAttr($domXML, $nomina, 'Version', "1.1");
		$this->addAttr($domXML, $nomina, 'RegistroPatronal', $info_nomina['config_usuario']['registro_patronal']);
		$this->addAttr($domXML, $nomina, 'NumEmpleado', $info_nomina['id_empleado']);
		$this->addAttr($domXML, $nomina, 'CURP', $info_nomina['receptor']['curp']);
		$this->addAttr($domXML, $nomina, 'TipoRegimen', $info_nomina['receptor']['tipo_regimen']);
		$this->addAttr($domXML, $nomina, 'NumSeguridadSocial', $info_nomina['receptor']['nss']);
		$this->addAttr($domXML, $nomina, 'FechaPago', $info_nomina['fecha_pago']);
		$this->addAttr($domXML, $nomina, 'FechaInicialPago', $info_nomina['fecha_inicial_pago']);
		$this->addAttr($domXML, $nomina, 'FechaFinalPago', $info_nomina['fecha_final_pago']);
		$this->addAttr($domXML, $nomina, 'NumDiasPagados', $info_nomina['num_dias_pagados']);
		$this->addAttr($domXML, $nomina, 'FechaInicioRelLaboral', $info_nomina['receptor']['fecha_contrato']); 
		$this->addAttr($domXML, $nomina, 'Antiguedad', $antiguedad); 
		$this->addAttr($domXML, $nomina, 'Puesto', $info_nomina['receptor']['puesto']); 
		$this->addAttr($domXML, $nomina, 'TipoContrato', $info_nomina['receptor']['tipo_contrato']); 
		$this->addAttr($domXML, $nomina, 'TipoJornada', $info_nomina['receptor']['tipo_jornada']); 
		$this->addAttr($domXML, $nomina, 'PeriodicidadPago', $info_nomina['periodicidad_pago']);
		$this->addAttr($domXML, $nomina, 'SalarioBaseCotApor', $info_nomina['receptor']['salario_base']); 
		$this->addAttr($domXML, $nomina, 'RiesgoPuesto', $info_nomina['receptor']['riesgo_puesto']); 
		$this->addAttr($domXML, $nomina, 'SalarioDiarioIntegrado', $info_nomina['receptor']['salario_diario']); 
		

		$percepciones = $domXML->createElement('nomina:Percepciones');
		$nomina->appendChild($percepciones);

		
		$this->addAttr($domXML, $percepciones, 'TotalGravado', $info_nomina['total_gravado_per']);
		$this->addAttr($domXML, $percepciones, 'TotalExento', $info_nomina['total_exento_per']);

		$cant_per = count($info_nomina['percepciones']);
		$info_percepcion = $info_nomina['percepciones'];
		for ($i = 0; $i < $cant_per; $i++) {

			$percepcion = $domXML->createElement('nomina:Percepcion');
			$percepciones->appendChild($percepcion);
			
			$tipo_per = str_pad($info_percepcion[$i]['tipo_percepcion'], 3, "0", STR_PAD_LEFT);
			$this->addAttr($domXML, $percepcion, 'TipoPercepcion', utf8_decode($tipo_per));
			$this->addAttr($domXML, $percepcion, 'Clave', $info_percepcion[$i]['clave']);
			$this->addAttr($domXML, $percepcion, 'Concepto', utf8_decode($info_percepcion[$i]['concepto']));
			$this->addAttr($domXML, $percepcion, 'ImporteGravado', $info_percepcion[$i]['importe_gravado']);
			$this->addAttr($domXML, $percepcion, 'ImporteExento', $info_percepcion[$i]['importe_exento']);
		}


		if($info_nomina['total_gravado_ded'] > 0 || $info_nomina['total_exento_ded'] >0){
			$deducciones = $domXML->createElement('nomina:Deducciones');
			$nomina->appendChild($deducciones);

			$this->addAttr($domXML, $deducciones, 'TotalGravado', $info_nomina['total_gravado_ded']);
			$this->addAttr($domXML, $deducciones, 'TotalExento', $info_nomina['total_exento_ded']);

			$cant_ded = count($info_nomina['deducciones']);
			$info_deduccion = $info_nomina['deducciones'];
			
			for ($i = 0; $i < $cant_ded; $i++) {

				$deduccion = $domXML->createElement('nomina:Deduccion');
				$deducciones->appendChild($deduccion);
				$tipo_ded = str_pad($info_deduccion[$i]['tipo_deduccion'], 3, "0", STR_PAD_LEFT);
				$this->addAttr($domXML, $deduccion, 'TipoDeduccion', utf8_decode($tipo_ded));
				$this->addAttr($domXML, $deduccion, 'Clave', $info_deduccion[$i]['clave']);
				$this->addAttr($domXML, $deduccion, 'Concepto', utf8_decode($info_deduccion[$i]['concepto']));
				$this->addAttr($domXML, $deduccion, 'ImporteGravado', $info_deduccion[$i]['importe_gravado']);
				$this->addAttr($domXML, $deduccion, 'ImporteExento', $info_deduccion[$i]['importe_exento']);
			}
		}
		//	$this->addAttr($domXML, $percepcion, 'TipoPercepcion', $info_nomina['total_exento_per']);
//		var_dump($info_nomina['id_nomina']);
		$return[] = array(
			'id_factura' => $info_nomina['id_nomina'],
			'rfc_emisor' => $info_nomina['emisor']['rfc'],
			'fecha_sellado' => date('Y-m-d H:i:s'),
			'xml' => $domXML->saveXML()
//			'xml' => $domXML->save("nomina2.xml")
		);
//		var_dump($return);
//		exit();
		return $return;
	}

	private function addAttr(&$domXML, &$obj, $attr, $val) {
		$attrNode = $domXML->createAttribute($attr);
		$obj->appendChild($attrNode);

		if ($val != '') {
			$txtNode = $domXML->createTextNode(utf8_encode($val));
			$attrNode->appendChild($txtNode);
		}
	}

}

?>