﻿<?php
require_once('./framework/classes/DBConnector.php');
require_once(FS_CLASSES . 'FacturasDAO.php');
require_once(FS_CLASSES . 'Municipios.php');
require_once(FS_CLASSES . 'Estados.php');
require_once(FS_CLASSES . 'UsuariosDAO.php');
require_once(FS_CLASSES . 'ClienteDAO.php');
require_once(FS_CLASSES . 'SucursalDAO.php');

class genera_xml extends DBConnector {

	public function xmlFactura($id_factura) {

		$return = array();
		$mun = new Municipios();
		$est = new Estados();
		$fac = new FacturasDAO();
		$emi = new UsuariosDAO();
		$rec = new ClienteDAO();
		$suc = new SucursalDAO();


		$factura = $fac->obtenerInformacionFactura($id_factura);		
		$rowsConceptos = $fac->listarConceptos($id_factura);
		$factura['emisor'] = $emi->recuperarUsuario($factura['id_usuario']);
		$factura['receptor'] = $rec->recuperarCliente($factura['id_cliente']);
		if ($factura['id_sucursal'] == 0) {
			$factura['sucursal'] = $suc->recuperarSucursal($factura['id_sucursal'], $factura['id_usuario']);
		} else {
			$factura['sucursal'] = $suc->recuperarSucursal($factura['id_sucursal']);
		}
		
		switch($factura['tipo_comprobante']){
			case 6:
				$tipo_comprobante = 'egreso';
			break;
			default:
				$tipo_comprobante = 'ingreso';
			break;
		}
	
		//====================================//
		//   Generacion de XML para Sellado   //
		//====================================//
		$pais = utf8_decode("México");
		$domXML = new DOMDocument('1.0', 'UTF-8');
		$domXML->formatOutput = true;
		$root = $domXML->createElement('cfdi:Comprobante');
		$root = $domXML->appendChild($root);
		//-- Atributos de Comprobante
		$this->addAttr($domXML, $root, 'version', '3.2');
		if (!empty($factura['serie'])) {
			$this->addAttr($domXML, $root, 'serie', $factura['serie']);
		}
		$this->addAttr($domXML, $root, 'folio', $factura['folio']);
		$this->addAttr($domXML, $root, 'fecha', date('Y-m-d') . "T" . date('H:i:s')); //str_replace(" ", "T", $factura['fecha_alta']));

		$this->addAttr($domXML, $root, 'sello', '');
		$this->addAttr($domXML, $root, 'formaDePago', $factura['forma_pago']);
		$this->addAttr($domXML, $root, 'noCertificado', '');
		$this->addAttr($domXML, $root, 'certificado', '');
		$this->addAttr($domXML, $root, 'subTotal', $factura['subtotal']);
		$this->addAttr($domXML, $root, 'total', $factura['total']);
		$this->addAttr($domXML, $root, 'tipoDeComprobante', $tipo_comprobante); // @TODO Obtenert el tipo de comprobante de una tabla.
		$this->addAttr($domXML, $root, 'metodoDePago', $factura['metodo_pago']);

		//-- Valida si se indican los ultimos 4 digitos de la identificacion de la cuenta de pago
		if (!empty($factura['digitos_tarjeta'])) {
			// ===========================================================
			// VERIFICAR CON SERVISIM PORQUE NO FUNCIONA CON ESTE ATRIBUTO
			// ===========================================================
//			$this->addAttr($domXML, $root, 'NumCtaPago', $factura['digitos_tarjeta']);
		}

		$this->addAttr($domXML, $root, 'LugarExpedicion', $factura['sucursal']['municipio'] . ", " . $factura['sucursal']['estado']);
		$this->addAttr($domXML, $root, 'xmlns:cfdi', 'http://www.sat.gob.mx/cfd/3');
		$this->addAttr($domXML, $root, 'xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
		$this->addAttr($domXML, $root, 'xmlns:implocal', 'http://www.sat.gob.mx/implocal');
		$this->addAttr($domXML, $root, 'xsi:schemaLocation', 'http://www.sat.gob.mx/cfd/3 '
				. 'http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv32.xsd ');


		$emisor = $factura['emisor'];
		//-- Atributos de Emisor
		$emisor_tag = $domXML->createElement('cfdi:Emisor');
		$root->appendChild($emisor_tag);
		$this->addAttr($domXML, $emisor_tag, 'rfc', $emisor['rfc']);
		$this->addAttr($domXML, $emisor_tag, 'nombre', $emisor['nombre']);

		//-- Domicilio Fiscal
		$dom_fiscal = $domXML->createElement('cfdi:DomicilioFiscal');
		$emisor_tag->appendChild($dom_fiscal);
		$this->addAttr($domXML, $dom_fiscal, 'calle', $emisor['calle']);
		$this->addAttr($domXML, $dom_fiscal, 'noExterior', $emisor['num_ext']);
//		$this->addAttr($domXML, $dom_fiscal, 'noInterior', (empty($emisor['num_int'])?'0':$emisor['num_int']));
		if (!empty($emisor['num_int'])) {
			$this->addAttr($domXML, $dom_fiscal, 'noInterior', $emisor['num_int']);
		}
		$this->addAttr($domXML, $dom_fiscal, 'colonia', $emisor['colonia']);
		$this->addAttr($domXML, $dom_fiscal, 'localidad', $emisor['municipio']);
		$this->addAttr($domXML, $dom_fiscal, 'referencia', '0');
		$this->addAttr($domXML, $dom_fiscal, 'municipio', $emisor['municipio']);
		$this->addAttr($domXML, $dom_fiscal, 'estado', $emisor['estado']);
		$this->addAttr($domXML, $dom_fiscal, 'pais', $pais);
		$this->addAttr($domXML, $dom_fiscal, 'codigoPostal', $emisor['codigo_postal']);

		$sucursal = $factura['sucursal'];
		//-- Datos de Expedicion
		$expedido = $domXML->createElement('cfdi:ExpedidoEn');
		$emisor_tag->appendChild($expedido);
		$this->addAttr($domXML, $expedido, 'calle', $sucursal['calle']);
		$this->addAttr($domXML, $expedido, 'noExterior', $sucursal['num_ext']);
//		$this->addAttr($domXML, $expedido, 'noInterior', (empty($sucursal['num_int'])?'0':$sucursal['num_int']));
		if (!empty($sucursal['num_int'])) {
			$this->addAttr($domXML, $expedido, 'noInterior', $sucursal['num_int']);
		}
		$this->addAttr($domXML, $expedido, 'colonia', $sucursal['colonia']);
		$this->addAttr($domXML, $expedido, 'localidad', $sucursal['municipio']);
		$this->addAttr($domXML, $expedido, 'referencia', '0');
		$this->addAttr($domXML, $expedido, 'municipio', $sucursal['municipio']);
		$this->addAttr($domXML, $expedido, 'estado', $sucursal['estado']);
		$this->addAttr($domXML, $expedido, 'pais', $pais);
		$this->addAttr($domXML, $expedido, 'codigoPostal', $sucursal['codigo_postal']);

		//-- Datos de Regimen Fiscal
		$regimen = $domXML->createElement('cfdi:RegimenFiscal');
		$emisor_tag->appendChild($regimen);
		$this->addAttr($domXML, $regimen, 'Regimen', $emisor['regimen_fiscal']);


		$receptor = $factura['receptor'];
		//-- Datos del Receptor
		$receptor_tag = $domXML->createElement('cfdi:Receptor');
		$root->appendChild($receptor_tag);
		$this->addAttr($domXML, $receptor_tag, 'rfc', $receptor['rfc']);
		$this->addAttr($domXML, $receptor_tag, 'nombre', $receptor['nombre']);

		//-- Datos del Domicilio del Receptor
		$domicilio = $domXML->createElement('cfdi:Domicilio');
		$receptor_tag->appendChild($domicilio);
		$this->addAttr($domXML, $domicilio, 'calle', $receptor['calle']);
		$this->addAttr($domXML, $domicilio, 'noExterior', $receptor['num_ext']);
//		$this->addAttr($domXML, $domicilio, 'noInterior', (empty($receptor['num_int'])?'0':$receptor['num_int']));
		if (!empty($receptor['num_int'])) {
			$this->addAttr($domXML, $domicilio, 'noInterior', $receptor['num_int']);
		}
		$this->addAttr($domXML, $domicilio, 'colonia', $receptor['colonia']);
		$this->addAttr($domXML, $domicilio, 'localidad', $receptor['municipio']);
		$this->addAttr($domXML, $domicilio, 'referencia', '0');
		$this->addAttr($domXML, $domicilio, 'municipio', $receptor['municipio']);
		$this->addAttr($domXML, $domicilio, 'estado', $receptor['estado']);
		$this->addAttr($domXML, $domicilio, 'pais', $pais);
		$this->addAttr($domXML, $domicilio, 'codigoPostal', $receptor['codigo_postal']);

		
		//-- Conceptos de la Factura
		$conceptos = $domXML->createElement('cfdi:Conceptos');
		$root->appendChild($conceptos);
		
		$arrayImpuestos = array();

		foreach ($rowsConceptos AS $item) {
			$concepto = $domXML->createElement('cfdi:Concepto');
			$conceptos->appendChild($concepto);
			
			$this->addAttr($domXML, $concepto, 'cantidad', $item['cantidad']);
			$this->addAttr($domXML, $concepto, 'unidad', $item['unidad']);
			$this->addAttr($domXML, $concepto, 'descripcion', preg_replace("/\r\n+|\r+|\n+|\t+/i", " ", $item['concepto']));
			$this->addAttr($domXML, $concepto, 'valorUnitario', $item['precio_unitario'] );
			$this->addAttr($domXML, $concepto, 'importe', $item['importe']);
			
			if($factura['tipo_formato'] == '2'){
				if(empty($arrayImpuestos['IVA'][$item['tasa_iva']]['tasa']) ){
					$arrayImpuestos['IVA'][$item['tasa_iva']]['importe'] = (string)$item['iva'];
					$arrayImpuestos['IVA'][$item['tasa_iva']]['tasa']	 = (string)$item['tasa_iva'];
				}else {
					$arrayImpuestos['IVA'][$item['tasa_iva']]['importe'] = (string)((float)$arrayImpuestos['IVA'][$item['tasa_iva']]['importe'] + (float)$item['iva']);
					$arrayImpuestos['IVA'][$item['tasa_iva']]['tasa'] = (string)$item['tasa_iva'];
				}
				
				if(empty($arrayImpuestos['IEPS'][$item['tasa_ieps']]['tasa'])){
					$arrayImpuestos['IEPS'][$item['tasa_ieps']]['importe'] = (string)($item['ieps']*$item['cantidad']);
					$arrayImpuestos['IEPS'][$item['tasa_ieps']]['tasa']	 = (string)$item['tasa_ieps'];
				}else{
					$arrayImpuestos['IEPS'][$item['tasa_ieps']]['importe'] = (string)((float)$arrayImpuestos['IVA'][$item['tasa_ieps']]['importe'] + (float)($item['ieps'])+($item['ieps']*$item['cantidad']));
					$arrayImpuestos['IEPS'][$item['tasa_ieps']]['tasa'] = (string)$item['tasa_ieps'];
				}
			}
		}

		//-- Datos de los Impuestos 
//		if ($factura['iva'] > 0) { //-- Se elimina la validacion para permitir comprobantes con tasa 0
		$impuestos = $domXML->createElement('cfdi:Impuestos');
		$root->appendChild($impuestos);

		if (floatval($factura['retencion_iva']) > 0 || floatval($factura['retencion_isr']) > 0) {
			$retenciones = $domXML->createElement('cfdi:Retenciones');
			$impuestos->appendChild($retenciones);
			
			if(floatval($factura['retencion_iva']) > 0){
				$retencion = $domXML->createElement('cfdi:Retencion');
				$retenciones->appendChild($retencion);
				$this->addAttr($domXML, $retencion, 'impuesto', 'IVA');
				$this->addAttr($domXML, $retencion, 'importe', $factura['retencion_iva']);
			}
			
			if(floatval($factura['retencion_isr']) > 0){
				$retencion = $domXML->createElement('cfdi:Retencion');
				$retenciones->appendChild($retencion);
				$this->addAttr($domXML, $retencion, 'impuesto', 'ISR');
				$this->addAttr($domXML, $retencion, 'importe', $factura['retencion_isr']);
			}
			
		}
//if (count($arrayImpuestos)) {
		$traslados = $domXML->createElement('cfdi:Traslados');
		$impuestos->appendChild($traslados);
		
		if($factura['tipo_formato'] == '2'){
			foreach($arrayImpuestos as $imp=>$val){
				foreach($val as $atr){
					$traslado = $domXML->createElement('cfdi:Traslado');
					$traslados->appendChild($traslado);
					$this->addAttr($domXML, $traslado, 'importe', number_format ($atr['importe'],2, ".", ""));
					$this->addAttr($domXML, $traslado, 'tasa', number_format ($atr['tasa'], 2, ".", ""));
					$this->addAttr($domXML, $traslado, 'impuesto', $imp);
				}
			}
		}else{
			$traslado = $domXML->createElement('cfdi:Traslado');
			$traslados->appendChild($traslado);
			$this->addAttr($domXML, $traslado, 'importe', $factura['iva']);
			$this->addAttr($domXML, $traslado, 'tasa', $factura['tasa_iva']);
			$this->addAttr($domXML, $traslado, 'impuesto', 'IVA');
		}

		
		if($factura['retencion_ieps'] > 0){
			//COMPLEMENTO PARA TRASLADO IEPS
			$complemento = $domXML->createElement('cfdi:Complemento');
			$root->appendChild($complemento);
			
			$impuesto_locales = $domXML->createElement('implocal:ImpuestosLocales');
			$complemento->appendChild($impuesto_locales);
			
			$this->addAttr($domXML, $impuesto_locales, 'TotaldeRetenciones', $factura['retencion_ieps']);
			$this->addAttr($domXML, $impuesto_locales, 'TotaldeTraslados', '0.0');
			$this->addAttr($domXML, $impuesto_locales, 'version', '1.0');
			
			$impLocal = $domXML->createElement('implocal:RetencionesLocales');
			$impuesto_locales->appendChild($impLocal);
			
			$this->addAttr($domXML, $impLocal, 'ImpLocRetenido', 'IEPS');
			$this->addAttr($domXML, $impLocal, 'Importe', $factura['retencion_ieps']);
			$this->addAttr($domXML, $impLocal, 'TasadeRetencion', $factura['retencion_ieps']);
		}
		
		
		$return[] = array(
			'id_factura' => $id_factura,
			'rfc_emisor' => $emisor['rfc'],
			'fecha_sellado' => date('Y-m-d H:i:s'),
			'xml' => $domXML->saveXML()
//			'xml' => $domXML->save("factura.xml")
		);

		return $return;
	}

	private function addAttr(&$domXML, &$obj, $attr, $val) {
		$attrNode = $domXML->createAttribute($attr);
		$obj->appendChild($attrNode);

		if ($val != '') {
			$txtNode = $domXML->createTextNode(utf8_encode($val));
			$attrNode->appendChild($txtNode);
		}
	}

}

?>